Subject: Re: [PATCH] TCP_FAILFAST: a new socket option to timeout/abort a connection quicker

From: Hagen Paul Pfeifer <[email-masked]>
Date: Thu, 26 Aug 2010 09:42:36 +0200

On Thu, 26 Aug 2010 09:12:24 +0200, Arnd Hannemann wrote:

>> USER_TIMEOUT is what is locally used for a connection (i.e., takes into

>> account what the remote peer advertised and what we'd like to use),

while

>> ADV_UTO is (only) what we'd like to use and are advertising.

>> (Yes, we initially thought we could make the mechanism simpler, but

then

>> we started to think through all the corner cases...)

> But from the application point of view it is enough to request a

> specific UTO

> as a socket option, (which will then get announced via ADV_UTO), right?

> Is there any reason, (besides local policy) to not abort the connection

> locally

> after the time the application specified via the above mentioned socket

> option?

The original USER_TIMEOUT (RFC 793) functionality boils down to Jerry's

TCP_FAILFAST patch. This _per see_ has no correlation with the ADV_UTO.

Likely that the ADV_UTO will update the USER_TIMEOUT too. I change my

position from day to day: artificially limit the mechanism and provide a

per see "clever" mechanism and keep both values coherent or provide all

freedom to the user.

Hagen